<!doctype html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Demos Berlin e.V.</title>
    <link rel="icon" type="image/x-icon" href="reveal.js/dist/theme/images/favicon.ico">

    <link rel="stylesheet" href="reveal.js/dist/reset.css">
    <link rel="stylesheet" href="reveal.js/dist/reveal.css">

    <!-- Theme used for slides -->
    <link rel="stylesheet" href="reveal.js/dist/theme/demos-dark.css">

    <!-- Theme used for syntax highlighting of code -->
    <link rel="stylesheet" href="reveal.js/plugin/highlight/monokai.css">
</head>
<body>
<div class="reveal">
    <div class="slides">
        <section data-background-image="reveal.js/dist/theme/images/BerlinWall.jpg">
            <div style="background-color: rgba(255,255,255,0.75);padding-left: 5px; padding-right: 5px; margin-left: 15%; margin-right: 15%;">
                <h3 style="text-align: left; color: black; margin: 0">Demos Berlin e.V.</h3>
                <h5 style="text-align: right; color: black">Tech Overview</h5>
            </div>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Challenges
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    * scalability
                        * app for everyone
                    * privacy
                        * collection not required
                        * avoid issues with law enforcement
                    * costs
                        * no funding
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Previous State and Issue
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    * MVP with [Adalo](https://www.adalo.com/)
                    * no code ownership
                    * unclear infrastructure
                    * costs
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Architecture
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Backend
                    ![rtfm](images/architecture.svg "Architecture Overview")
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Backend
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Tech Stack
                    * Language: [Python](https://www.python.org/)
                    * Framework: [FastAPI](https://fastapi.tiangolo.com/)
                    * ORM: [sqlmodel](https://sqlmodel.tiangolo.com/)
                    * Migrations: [Alembic](https://alembic.sqlalchemy.org/en/latest/)
                    * ODM & Migrations: [Beanie](https://beanie-odm.dev/)
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Frontend
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Tech Stack
                    * Language: [TypeScript](https://www.typescriptlang.org/)
                    * Framework: [Quasar](https://quasar.dev/)
                    * Maps: [Leaflet](https://leafletjs.com/)
                        * Map Data: [OpenStreetMap](https://www.openstreetmap.org)
                    * HTTP Client: [Axios](https://axios-http.com/)
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Infrastructure
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Servers
                    * Virtual Servers at [Hetzner](https://www.hetzner.com/)
                        * Falkenstein, GER, EU
                        * Nuernberg, GER, EU
                    * Mail Server at [Google](https://www.google.com/)
                        * unclear location
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### List of Servers
                    * Production
                    * Staging
                    * Mattermost
                    * GitLab Runner
                    * (Big Blue Button)
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Provisioning
                    * [Ansible](https://www.ansible.com/)
                        * [Ubuntu Server](https://ubuntu.com/download/server) 20.04
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Domains
                    * donated by Humberto
                    * managed by [Strato](https://www.strato.de/)
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Source Code
                    * SCM: [git](https://git-scm.com/)
                    * VCS: [GitLab](https://gitlab.com)
                        * set up CI/CD
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Costs
                    * Hetzner: 37EUR / month
                    * Strato: 1EUR / month
                        * after the first year: 8EUR / month
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Privacy
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Logging
                    * user data logging disabled
                    * error logs: TBD
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    #### Third Parties
                    * Map Data: [OpenStreetMap](https://www.openstreetmap.org)
                    * Translation: [Google](https://www.google.com/)
                    * Mail: [Google](https://www.google.com/)
                    * Geolocation: [Nominatim](https://nominatim.org/)
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Outlook
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    ### Backend
                    * Log Aggregation
                    * Monitoring
                    * Alerts
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    ### Frontend
                    * Cross Compilation as Mobile Apps
                </textarea>
            </section>
            <section data-markdown>
                <textarea data-template>
                    ### Meta
                    * Licensing
                      * CLA
                    * Open-Sourcing
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Links and further information
                    * [Demos Berlin e.V. GitLab group](https://gitlab.com/demos-berlin-ev)
                    * join [our Mattermost](https://mm.demonstrations.org) for fast team communication
                    * [src code](https://gitlab.com/demos-berlin-ev/presentations/tech-overview) of this presentation
                </textarea>
            </section>
        </section>
        <section>
            <section data-markdown>
                <textarea data-template>
                    ### Questions!
                </textarea>
            </section>
        </section>
    </div>
</div>

<script src="reveal.js/dist/reveal.js"></script>
<script src="reveal.js/plugin/zoom/zoom.js"></script>
<script src="reveal.js/plugin/notes/notes.js"></script>
<script src="reveal.js/plugin/search/search.js"></script>
<script src="reveal.js/plugin/markdown/markdown.js"></script>
<script src="reveal.js/plugin/highlight/highlight.js"></script>
<script>

    // Also available as an ES module, see:
    // https://revealjs.com/initialization/
    Reveal.initialize({
        controls: true,
        progress: true,
        center: true,
        hash: true,
        fragments: true,
        slideNumber: 'c/t',
        width: '60%',
        markdown:
            {
                smartypants: true
            },

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealZoom, RevealNotes, RevealSearch, RevealMarkdown, RevealHighlight ]
    });

</script>
</body>
</html>

